#include "../host/inc/linear_classifier.h"
#include "../host/inc/weights_linear_classifier.h"

#ifndef SIMD_WORK_ITEMS
#define SIMD_WORK_ITEMS 2 // must be a power of two, and divisible with number of kernels
#endif

#ifndef NUM_COMPUTE_UNITS
#define NUM_COMPUTE_UNITS 2
#endif

__kernel
__attribute((reqd_work_group_size(10,1,1)))
//__attribute((max_work_group_size(10)))
__attribute((num_simd_work_items(SIMD_WORK_ITEMS)))
//__attribute((num_compute_units(NUM_COMPUTE_UNITS)))
void linear_classifier(
                 // Input and output matrices
                 __global float *restrict Y,
                 __global float *restrict X)
{
    // Global ID index (offset within the NDRange)
    //int global_id = get_global_id(0);

    // Local ID index (offset within work group)
    int local_id = get_local_id(0);

    float running_sum = 0.0f;

    for (int k = 0; k < W_x; ++k)
    {
        running_sum += W[local_id][k] * X[k];
    }
    barrier(CLK_LOCAL_MEM_FENCE); // try remove this

    // Store result in matrix Y
    Y[local_id] = running_sum;
}
